Foxit PDF SDK

Public Member Functions | Static Public Member Functions | List of all members
FSDK.ImageObject Class Reference
Inheritance diagram for FSDK.ImageObject:

## Public Member Functions
| CloneBitmap (graphics_objects)
| Clone the bitmap from current image graphics object. More...
| CloneBitmap (page, graphics_objects)
| Clone the bitmap from current image graphics object. More...
| GetColorSpace ()
| Get color space. More...
| GetMask ()
| Get the PDF object that represents the mask of current image graphics object. More...
| GetStream ()
| Get image stream. More...
| IsImageMask ()
| Check if current image object is treated as mask. More...
| SetBitmap (bitmap, mask)
| Set a bitmap to current image graphics object. More...
| SetImage (image, frame_index)
| Set one frame of an image to current image graphics object. More...
Public Member Functions inherited from FSDK.GraphicsObject
| AddClipPath (path, fill_mode)
| Add a path for clipping. More...
| AddClipTextObject (textobject)
| Add text object for clipping. More...
| ClearClips ()
| Clear all clips. More...
| Clone ()
| Clone a new graphics object. More...
| Clone (src_graphicsobjects, dest_graphicsobjects)
| Clone a new graphics object. More...
| GetBlendMode ()
| Get the blend mode for transparent imaging model. More...
| GetClipPath (index)
| Get a path clip by index. More...
| GetClipPathCount ()
| Get the count of path clip. More...
| GetClipPathFillMode (index)
| Get the fill mode of a path clip by index. More...
| GetClipRect ()
| Get clip rectangle. More...
| GetClipTextObject (index)
| Get the text object of a text clip by index. More...
| GetClipTextObjectCount ()
| Get the count of text clip. More...
| GetColorState ()
| Get color state. More...
| GetFillColor ()
| Get the fill color. More...
| GetFillOpacity ()
| Get the opacity value for painting operations other than stroking. More...
| GetFormXObject ()
| Get the form XObject graphics object if current graphics object represents a form XObject object. More...
| GetGraphState ()
| Get graph state. More...
| GetImageObject ()
| Get the image graphics object if current graphics object represents an image object. More...
| GetLayers (layer_tree)
| Get all the layers which are associated with current graphics object. More...
| GetMarkedContent ()
| Get marked content object. More...
| GetMatrix ()
| Get matrix. More...
| GetPathObject ()
| Get the path graphics object if current graphics object represents a path object. More...
| GetRect ()
| Get the rectangle of current graphics object. More...
| GetShadingObject ()
| Get the shading graphics object if current graphics object represents a shading object. More...
| GetStrokeColor ()
| Get the stroke color. More...
| GetStrokeOpacity ()
| Get opacity value for stroke painting operations for paths and glyph outlines. More...
| GetTextObject ()
| Get the text graphics object if current graphics object represents a text object. More...
| GetType ()
| Get the type of current graphics object. More...
| HasTransparency ()
| Check whether current PDF page has transparency or not. More...
| IsScanned ()
| Check whether current PDF page is scanned page or not. More...
| Release ()
| Release a cloned or newly created PDF graphics object which has not been inserted into any PDF page or other object. More...
| RemoveClipPath (index)
| Remove a path clip by index. More...
| RemoveClipTextObject (index)
| Remove a text clip by index for clipping. More...
| Rotate (angle)
| Rotate current graphics object from current state with specified angle degree in clockwise. More...
| SetBlendMode (blend_mode)
| Set the blend mode for transparent imaging model. More...
| SetClipRect (clip_rect)
| Set clip rectangle. More...
| SetColorState (color_state)
| Set color state. More...
| SetFillColor (color)
| Set the fill color. More...
| SetFillOpacity (opacity)
| Set the opacity value for painting operations other than stroking. More...
| SetGraphState (graph_state)
| Set graph state. More...
| SetMatrix (matrix)
| Set matrix. More...
| SetStrokeColor (color)
| Set the stroke color. More...
| SetStrokeOpacity (opacity)
| Set opacity value for stroke painting operations for paths and glyph outlines. More...
| Transform (matrix, need_transform_clippath)
| Transform current graphics object. More...

## Static Public Member Functions
static | Create (document)
| Create a new image graphics object. More...
static | CreateFromType3TextObject (page, text_obj)
| Create an image graphics object from a type3 text object. More...

## Additional Inherited Members
Static Public Attributes inherited from FSDK.GraphicsObject
static | e_BlendColor
| Creates a color with the hue and saturation of the source color, and the luminosity of the backdrop color. More...
static | e_BlendColorBurn
| Darkens backdrop color to reflect the source color. More...
static | e_BlendColorDodge
| Brightens backdrop color to reflect source colors. More...
static | e_BlendDarken
| Select darker one of backdrop and source colors. More...
static | e_BlendDifference
| Subtracts the darker of the two constituent colors from lighter colors. More...
static | e_BlendExclusion
| Creates a color with the hue of the source color, and the saturation and luminosity of the backdrop color. More...
static | e_BlendHardlight
| Multiply or screens colors, depending on source color value. More...
static | e_BlendHue
| Creates a color with the hue of the source color, and the saturation and luminosity of the backdrop color. More...
static | e_BlendLighten
| Select lighter one of backdrop and source colors. More...
static | e_BlendLuminosity
| Creates a color with the luminosity of the source color, and the hue and saturation of the backdrop color. More...
static | e_BlendMultiply
| Multiply backdrop by source color values. More...
static | e_BlendNormal
| Enumeration for render blend mode. More...
static | e_BlendOverlay
| Multiply or screens colors, depending on backdrop color value. More...
static | e_BlendSaturation
| Creates a color with the saturation of the source color, and the hue and luminosity of the backdrop color. More...
static | e_BlendScreen
| Multiply complements of backdrop by source color values, and then complement the result. More...
static | e_BlendSoftlight
| Darkens or lightens colors, depending on source color value. More...
static | e_TypeAll
| Enumeration for PDF graphics object type. More...
static | e_TypeFormXObject
| Form XObject graphics object.
static | e_TypeImage
| Image graphics object.
static | e_TypePath
| Path graphics object.
static | e_TypeShading
| Shading graphics object.
static | e_TypeText
| Text graphics object.

## Detailed Description

Image graphics object is a kind of PDF graphics object, so class FSDK.ImageObject is derived from class FSDK.GraphicsObject. It offers functions to get/set image graphics object's data.
To create a new image graphics object, please use function FSDK.ImageObject.Create and then use setting functions to set information to the new image graphics object.

See also
  FSDK.GraphicsObject

## Member Function Documentation

## ◆ CloneBitmap() [1/2]

FSDK.ImageObject.CloneBitmap | ( | graphics_objects |  | ) |

Clone the bitmap from current image graphics object.

Deprecated:
  This function is deprecated. Use function FSDK.ImageObject.CloneBitmap with two parameters instead.

Currently, the bitmap can be cloned from image graphics object only when the bitmap format is one of following formats:
FSDK.Bitmap.e_DIB8bppMask, FSDK.Bitmap.e_DIB8bpp, FSDK.Bitmap.e_DIBRgb, FSDK.Bitmap.e_DIBRgb32, FSDK.Bitmap.e_DIBArgb, FSDK.Bitmap.e_DIBCmyk.
If the return value of function FSDK.Bitmap.IsEmpty for the returned bitmap object is true, that means the DIB format of the bitmap is unsupported.

Parameters

  [in] | graphics_objects | A valid FSDK.GraphicsObjects object. Please ensure that current image graphics object just belongs to this FSDK.GraphicsObjects object (it may be a PDF page).

Returns
  The new cloned bitmap object. If the return value of function FSDK.Bitmap.IsEmpty for the returned bitmap object is true, that means the DIB format of the bitmap is unsupported.

## ◆ CloneBitmap() [2/2]

FSDK.ImageObject.CloneBitmap | ( | page | ,
|  | graphics_objects |
| ) |  |

Clone the bitmap from current image graphics object.

Currently, the bitmap can be cloned from image graphics object only when the bitmap format is one of following formats:
FSDK.Bitmap.e_DIB8bppMask, FSDK.Bitmap.e_DIB8bpp, FSDK.Bitmap.e_DIBRgb, FSDK.Bitmap.e_DIBRgb32, FSDK.Bitmap.e_DIBArgb, FSDK.Bitmap.e_DIBCmyk.
If the return value of function FSDK.Bitmap.IsEmpty for the returned bitmap object is true, that means the DIB format of the bitmap is unsupported.

Parameters

  [in] | page | A valid PDF page object. Please ensure that current image graphics object just belongs to this page.
  [in] | graphics_objects | A valid FSDK.GraphicsObjects object. Please ensure that current image graphics object just belongs to this FSDK.GraphicsObjects object (it may be a PDF page).

Returns
  The new cloned bitmap object. If the return value of function FSDK.Bitmap.IsEmpty for the returned bitmap object is true, that means the DIB format of the bitmap is unsupported.

## ◆ Create()

static FSDK.ImageObject.Create | ( | document |  | ) |
| static

Create a new image graphics object.

The newly created image graphics object does not have any data yet. Then, setting functions can be called to set data to the new image graphics object. If the newly created image graphics object will not inserted to any page or other objects, please remember to call function FSDK.GraphicsObject.Release to release it when no use.

Parameters

  [in] | document | A valid PDF document object. The new image graphics object should be inserted to one page of this PDF document then.

Returns
  A new image object. If there is any error, this function will return null.

## ◆ CreateFromType3TextObject()

static FSDK.ImageObject.CreateFromType3TextObject | ( | page | ,
|  | text_obj |
| ) |  |
| static

Create an image graphics object from a type3 text object.

If the newly created image graphics object will not inserted to any page or other objects, please remember to call function FSDK.GraphicsObject.Release to release it when no use.

Parameters

  [in] | page | A valid PDF page object.
  [in] | text_obj | A valid text object. This text object should be a type3 text object.

Returns
  A new image object. If there is any error, this function will return NULL.

## ◆ GetColorSpace()

FSDK.ImageObject.GetColorSpace | ( |  | ) |

Get color space.

Returns
  Color space. Please refer to values starting from FSDK.e_ColorSpaceDeviceGray and this would be one of these values.

## ◆ GetMask()

FSDK.ImageObject.GetMask | ( |  | ) |

Get the PDF object that represents the mask of current image graphics object.

The mask can be either a PDF dictionary or a PDF array:

- A PDF dictionary represents an image mask to be applied to this image.
- A PDF array represents a range of colors to be applied to it as a color key mask.

Please refer to Section 4.8.4 "Image Dictionaries" in <PDF Reference 1.7> for more details.

Returns
  A PDF object that represents the mask. If FSDK.ImageObject.IsImageMask returns true, this function will return null.

## ◆ GetStream()

FSDK.ImageObject.GetStream | ( |  | ) |

Get image stream.

Returns
  A FSDK.PDFStream that represents the image stream. If there is any error, this function will return null.

## ◆ IsImageMask()

FSDK.ImageObject.IsImageMask | ( |  | ) |

Check if current image object is treated as mask.

Returns
  true means current object is treated as mask, while false means not.

## ◆ SetBitmap()

FSDK.ImageObject.SetBitmap | ( | bitmap | ,
|  | mask |
| ) |  |

Set a bitmap to current image graphics object.

Parameters

  [in] | bitmap | A valid bitmap object to be set to current image.
  [in] | mask | Mask bitmap. Default value: A bitmap object by default constructor and not set any value, which means no mask is used. If this is valid, its format should be FSDK.Bitmap.e_DIB8bppMask. This is useful only when parameter bitmap does not have an alpha channel.

Returns
  None

Note
  When this function succeeds, function FSDK.GraphicsObjects.GenerateContent should be called. Please refer to function FSDK.GraphicsObjects.GenerateContent for more details.

## ◆ SetImage()

FSDK.ImageObject.SetImage | ( | image | ,
|  | frame_index |
| ) |  |

Set one frame of an image to current image graphics object.

Input image may contain multiple frames, and only one frame of the image can be set to current image graphics object.

Parameters

  [in] | image | A valid image object. This image should contain at least one frame and the image type should not be FSDK.Image.e_Unknown.
  [in] | frame_index | Frame index used to decide which frame of parameter image is to be set. Valid range: from 0 to (count-1). count is returned by function FSDK.Image.GetFrameCount.

Returns
  None

Note
  When this function succeeds, function FSDK.GraphicsObjects.GenerateContent should be called. Please refer to function FSDK.GraphicsObjects.GenerateContent for more details.